<i18n lang="yml">
en:
  search: "Search"
  cluster_location: "location"
  quarter: "quarter"
  area: "area"
nl:
  search: "Zoek"
  cluster_location: "locatie"
  quarter: "wijk"
  area: "gebied"
</i18n>

<template>
  <AmsAutoComplete
    :input-id="filterId"
    :options="options.map(o => {
      return { code: o === noFilterString ? '' : o, label: $t(o) };
    })"
    :selected-option="selected"
    :placeholder="`${$t('search')} ${$t(filterId)}`"
    :variant="variant"
    :class="[
      $style['filterinput'],
      { 'filter-applied': curVal !== '' },
    ]"
    @gotInput="onFilterInput"
  />
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  onBeforeUnmount,
} from "@nuxtjs/composition-api";
import useFiltering from "~/composables/filtering";

export default defineComponent({
  name: "AmsFilterInput",

  components: {
    AmsAutoComplete: () => import("~/components/_patterns/Form/AutoComplete.vue"),
  },

  props: {
    filterId: {
      type: String,
      default: null,
    },
    noFilterString: {
      type: String,
      default: "",
    },
    variant: {
      type: String,
      default: "outlined",
    },
    currentValue: {
      type: String,
      default: "",
    },
  },

  setup (props, ctx) {
    const { filter, uniqueValuesPerFilterableColumn } = useFiltering();

    const curVal = computed(() => props.currentValue);

    const options = computed((): string[] => {
      return uniqueValuesPerFilterableColumn[props.filterId];
    });

    const selected = computed(() => {
      return options.value.findIndex(cur => cur === curVal.value);
    });

    function onFilterInput ({ value, id }) {
      filter(value, id);
      ctx.emit("filterApplied", { value, id });
    }

    onBeforeUnmount(() => filter());

    return {
      curVal,
      options,
      selected,
      onFilterInput,
    };
  },
});
</script>

<style lang="postcss" module>
.filterinput {
  height: 30px;

  @apply relative flex justify-center items-center mt-1 mx-2;
}
</style>

<style lang="postcss" scoped>
.filter-applied.outlined {
  @apply bg-gray-600 text-gray-150;
}
</style>
